﻿
Public Class Form1

    Dim Avvio As DateTime
    Dim FileTesto As String = IO.Path.Combine(Application.StartupPath, "DurataBatteria.txt")

    Private Sub ButAVVIA_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ButAVVIA.Click

        Avvio = Now
        Dim riga1 As String = "TEST iniziato alle: " & Avvio
        Dim riga2 As String = "Salvataggio file su: " & FileTesto

        ListBox1.Items.Clear()
        ListBox1.Items.Add(riga1)
        ListBox1.Items.Add("Il file: DurataBatteria.txt se esiste viene sovrascritto.")
        ListBox1.Items.Add(riga2)

        Using outputFile As New IO.StreamWriter(FileTesto, False)
            outputFile.Write(riga1 & Environment.NewLine)
            outputFile.Write(riga2 & Environment.NewLine)
        End Using

        Me.Text = "TestBatteria in corso"
        Timer1.Enabled = True
        Timer1_Tick(Timer1, New System.EventArgs)

    End Sub

    Private Sub Timer1_Tick(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Timer1.Tick

        Dim Percentuale As Single = SystemInformation.PowerStatus.BatteryLifePercent * 100
        Dim stato As String = Percentuale & "%, trascorso: " & Now.Subtract(Avvio).ToString.Substring(0, 8)
        Dim info As String = Percentuale & "%"
        Dim riga As String = ""

        Select Case SystemInformation.PowerStatus.PowerLineStatus
            Case PowerLineStatus.Online
                If SystemInformation.PowerStatus.BatteryChargeStatus = BatteryChargeStatus.High Then
                    info = "FULL"
                    riga = "Batteria carica" & stato
                Else
                    riga = "Batteria in carica " & stato
                End If
            Case PowerLineStatus.Offline
                riga = "Batteria in scarica " & stato
            Case PowerLineStatus.Unknown
                riga = "Stato linea sconosciuto " & stato
        End Select

        If SystemInformation.PowerStatus.BatteryChargeStatus = BatteryChargeStatus.NoSystemBattery Then
            riga = "Batteria assente, trascorso: " & Now.Subtract(Avvio).ToString.Substring(0, 8)
            PictureBox1.BorderStyle = BorderStyle.FixedSingle
            PictureBox1.BackgroundImage = Nothing
        Else
            Dim immagine As Integer = Math.Round(Percentuale / 10)
            Dim bmp As Image = Nothing

            Select Case immagine
                Case 0
                    bmp = My.Resources._00
                Case 1
                    bmp = My.Resources._01
                Case 2
                    bmp = My.Resources._02
                Case 3
                    bmp = My.Resources._03
                Case 4
                    bmp = My.Resources._04
                Case 5
                    bmp = My.Resources._05
                Case 6
                    bmp = My.Resources._06
                Case 7
                    bmp = My.Resources._07
                Case 8
                    bmp = My.Resources._08
                Case 9
                    bmp = My.Resources._09
                Case 10
                    bmp = My.Resources._10
            End Select

            Dim g As Graphics = Graphics.FromImage(bmp)
            g.TextRenderingHint = Drawing.Text.TextRenderingHint.AntiAliasGridFit
            Dim tipofont As Font = New Font("Arial", 80, FontStyle.Bold)
            Dim dimstring As SizeF = g.MeasureString(info, tipofont)
            g.DrawString(info, tipofont, Brushes.DarkGray, bmp.Width / 2 - dimstring.Width / 2 + 3, bmp.Height / 2 - dimstring.Height / 2 + 33)
            g.DrawString(info, tipofont, Brushes.Blue, bmp.Width / 2 - dimstring.Width / 2, bmp.Height / 2 - dimstring.Height / 2 + 30)
            PictureBox1.BorderStyle = BorderStyle.None
            PictureBox1.BackgroundImage = bmp
        End If

        ListBox1.Items.Add(riga)
        ListBox1.TopIndex = ListBox1.Items.Count - 1
        Using outputFile As New IO.StreamWriter(FileTesto, True)
            outputFile.Write(riga & Environment.NewLine)
        End Using

    End Sub

    Private Sub Button1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button1.Click
        Timer1.Enabled = False
        Me.Text = "TestBatteria arrestato"
    End Sub

End Class
